Removes vpp-devel from package install
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16
17   # OPNFV Default Environment and Network settings
18   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
19   DEPLOY_OPTIONS+=" -e network-environment.yaml"
20
21   # Custom Deploy Environment Templates
22   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
23     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
24       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
25     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
26       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
27       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
28         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
29       fi
30     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
31       if [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
32         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
33       else
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
35       fi
36     else
37       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
38     fi
39     SDN_IMAGE=opendaylight
40   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
41     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
42     SDN_IMAGE=opendaylight
43   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
44     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
45     exit 1
46     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
47     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
48     #else
49     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
50     #fi
51     #SDN_IMAGE=onos
52   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
53     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
54     exit 1
55   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
56     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
57     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
58       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-networking-vpp.yaml"
59     fi
60     SDN_IMAGE=opendaylight
61   else
62     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
63     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
64     exit 1
65   fi
66
67   # Enable Tacker
68   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
69     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
70   fi
71
72   # Enable Congress
73   if [ "${deploy_options_array['congress']}" == 'True' ]; then
74     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
75   fi
76
77   # Enable Real Time Kernel (kvm4nfv)
78   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
79     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
80   fi
81
82   # Make sure the correct overcloud image is available
83   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
84       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
85       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
86       exit 1
87   fi
88
89   echo "Copying overcloud image to Undercloud"
90   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
91   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
92
93   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
94       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
95       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
96       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
97                                                --run-command "systemctl enable zrpcd" \
98                                                -a overcloud-full.qcow2
99 EOI
100   fi
101
102   # Install ovs-dpdk inside the overcloud image if it is enabled.
103   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
104     # install dpdk packages before ovs
105     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
106
107     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
108       cat << EOF > vfio_pci.modules
109 #!/bin/bash
110 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
111 EOF
112
113       cat << EOF > uio_pci_generic.modules
114 #!/bin/bash
115 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
116 EOF
117
118       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
119                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
120                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
121                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
122                                                -a overcloud-full.qcow2
123
124       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
125         LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/dpdk_rpms/*" \
126                                                  --run-command "sed -i '/RuntimeDirectoryMode=.*/d' /usr/lib/systemd/system/openvswitch-nonetwork.service" \
127                                                  --run-command "printf \"%s\\n\" RuntimeDirectoryMode=0775 Group=qemu UMask=0002 >> /usr/lib/systemd/system/openvswitch-nonetwork.service" \
128                                                  --run-command "sed -i 's/\\(^\\s\\+\\)\\(start_daemon "$OVS_VSWITCHD_PRIORITY"\\)/\\1umask 0002 \\&\\& \\2/' /usr/share/openvswitch/scripts/ovs-ctl" \
129                                                  -a overcloud-full.qcow2
130       fi
131
132 EOI
133
134   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
135     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
136     exit 1
137   fi
138
139   if [ "$debug" == 'TRUE' ]; then
140     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
141   fi
142
143   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
144   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
145     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
146          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
147                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
148                                                   -a overcloud-full.qcow2
149 EOI
150   fi
151
152   #Configure routing node for odl_l3-fdio
153   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['dataplane']}" == 'fdio' && "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
154     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
155        sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
156 EOI
157   fi
158
159   if [ -n "${deploy_options_array['performance']}" ]; then
160     for option in "${performance_options[@]}" ; do
161     arr=($option)
162     # use compute's kernel settings for all nodes for now.
163     if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
164       kernel_args+=" ${arr[2]}=${arr[3]}"
165     fi
166     done
167
168     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
169        sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
170        sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
171        sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
172 EOI
173   fi
174
175   # Set ODL version accordingly
176   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
177     case "${deploy_options_array['odl_version']}" in
178       beryllium) odl_version=''
179               ;;
180       boron)  odl_version='boron'
181               ;;
182       carbon) odl_version='master'
183               ;;
184       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
185          exit 1
186          ;;
187     esac
188
189     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
190       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
191                                                --run-command "yum -y install /root/${odl_version}/*" \
192                                                -a overcloud-full.qcow2
193 EOI
194   fi
195
196   # Override any previous packages if FDIO and L2
197   if [[ "${deploy_options_array['vpp']}" == 'True' && "${deploy_options_array['sdn_l3']}" == "False" ]]; then
198     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
199          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight vpp vpp-api-python vpp-lib vpp-plugins honeycomb" \
200                                                   --run-command "yum -y install /root/fdio_l2/*.rpm" \
201                                                   --run-command "rm -f /etc/sysctl.d/80-vpp.conf" \
202                                                   -a overcloud-full.qcow2
203 EOI
204   fi
205
206   # check if ceph should be enabled
207   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
208     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
209   fi
210
211   # get number of nodes available in inventory
212   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
213   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
214
215   # check if HA is enabled
216   if [[ "$ha_enabled" == "True" ]]; then
217     if [ "$num_control_nodes" -lt 3 ]; then
218       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
219       exit 1
220     else
221      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
222      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
223      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
224     fi
225   else
226     if [ "$num_control_nodes" -lt 1 ]; then
227       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
228       exit 1
229     fi
230   fi
231
232   if [ "$num_compute_nodes" -le 0 ]; then
233     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
234     exit 1
235   else
236     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
237     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
238   fi
239
240   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
241
242   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
243   if [[ "$virtual" == "TRUE" ]]; then
244      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
245   fi
246
247   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
248
249   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
250 # Create a key for use by nova for live migration
251 echo "Creating nova SSH key for nova resize support"
252 ssh-keygen -f nova_id_rsa -b 1024 -P ""
253 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
254 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
255 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
256 mv -f opnfv-environment-new.yaml ${ENV_FILE}
257
258 source stackrc
259 set -o errexit
260 # Workaround for APEX-207 where sometimes swift proxy is down
261 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
262   sudo systemctl restart openstack-swift-proxy
263 fi
264 echo "Uploading overcloud glance images"
265 openstack overcloud image upload
266
267 echo "Configuring undercloud and discovering nodes"
268 openstack baremetal import --json instackenv.json
269
270 if [[ -z "$virtual" ]]; then
271   openstack baremetal introspection bulk start
272   if [[ -n "$root_disk_list" ]]; then
273     openstack baremetal configure boot --root-device=${root_disk_list}
274   else
275     openstack baremetal configure boot
276   fi
277 else
278   openstack baremetal configure boot
279 fi
280
281 echo "Configuring flavors"
282 for flavor in baremetal control compute; do
283   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
284   if openstack flavor list | grep \${flavor}; then
285     openstack flavor delete \${flavor}
286   fi
287   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
288   if ! openstack flavor list | grep \${flavor}; then
289     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
290   fi
291 done
292 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
293 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
294 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
295 echo "Configuring nameserver on ctlplane network"
296 dns_server_ext=''
297 for dns_server in ${dns_servers}; do
298   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
299 done
300 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
301 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
302 echo "Executing overcloud deployment, this should run for an extended period without output."
303 sleep 60 #wait for Hypervisor stats to check-in to nova
304 # save deploy command so it can be used for debugging
305 cat > deploy_command << EOF
306 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
307 EOF
308 EOI
309
310   if [ "$interactive" == "TRUE" ]; then
311     if ! prompt_user "Overcloud Deployment"; then
312       echo -e "${blue}INFO: User requests exit${reset}"
313       exit 0
314     fi
315   fi
316
317   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
318 source stackrc
319 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
320 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
321   $(typeset -f debug_stack)
322   debug_stack
323   exit 1
324 fi
325 EOI
326
327   # Configure DPDK
328   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
329     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
330 source stackrc
331 set -o errexit
332 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
333 echo "Running DPDK test app on \$node"
334 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
335 set -o errexit
336 sudo dpdk_helloworld --no-pci
337 sudo dpdk_nic_bind -s
338 EOF
339 done
340 EOI
341   fi
342
343   if [ "$debug" == 'TRUE' ]; then
344       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
345 source overcloudrc
346 echo "Keystone Endpoint List:"
347 openstack endpoint list
348 echo "Keystone Service List"
349 openstack service list
350 EOI
351   fi
352 }